=== modified file 'drizzled/plugin/storage_engine.cc'
--- drizzled/plugin/storage_engine.cc	2010-12-28 16:57:38 +0000
+++ drizzled/plugin/storage_engine.cc	2010-12-22 21:50:32 +0000
@@ -1180,14 +1180,7 @@
   return false;
 }
 
-std::ostream& operator<<(std::ostream& output, const StorageEngine &engine)
-{
-  output << "StorageEngine:(";
-  output <<  engine.getName();
-  output << ")";
 
-  return output;
-}
 
 } /* namespace plugin */
 } /* namespace drizzled */

=== modified file 'drizzled/plugin/storage_engine.h'
--- drizzled/plugin/storage_engine.h	2010-12-28 16:57:38 +0000
+++ drizzled/plugin/storage_engine.h	2010-12-24 04:29:32 +0000
@@ -448,8 +448,6 @@
   }
 };
 
-std::ostream& operator<<(std::ostream& output, const StorageEngine &engine);
-
 } /* namespace plugin */
 } /* namespace drizzled */
 

=== modified file 'drizzled/sql_lex.cc'
--- drizzled/sql_lex.cc	2010-12-28 16:57:38 +0000
+++ drizzled/sql_lex.cc	2010-11-03 16:49:41 +0000
@@ -281,8 +281,6 @@
   }
 
   delete result;
-  delete _create_table;
-  _create_table= NULL;
 
   result= 0;
   setCacheable(true);
@@ -1803,11 +1801,6 @@
   }
 }
 
-LEX::~LEX()
-{
-  delete _create_table;
-}
-
 /**
   @brief Restore the LEX and Session in case of a parse error.
 
@@ -1880,8 +1873,7 @@
     option_type(OPT_DEFAULT), 
     is_lex_started(0),
     cacheable(true),
-    sum_expr_used(false),
-    _create_table(NULL)
+    sum_expr_used(false)
 {
   reset_query_tables_list(true);
   statement= NULL;

=== modified file 'drizzled/sql_lex.h'
--- drizzled/sql_lex.h	2010-12-28 16:57:38 +0000
+++ drizzled/sql_lex.h	2010-12-24 07:15:43 +0000
@@ -930,7 +930,9 @@
      statement in a session. It's re-used by doing lex_end, lex_start
      in sql_lex.cc
   */
-  virtual ~LEX();
+  virtual ~LEX()
+  {
+  }
 
   TableList *unlink_first_table(bool *link_to_local);
   void link_first_table_back(TableList *first, bool link_to_local);
@@ -1008,18 +1010,9 @@
   void start(Session *session);
   void end();
 
-  message::Table *table()
-  {
-    if (not _create_table)
-      _create_table= new message::Table;
-
-    return _create_table;
-  }
-
 private: 
   bool cacheable;
   bool sum_expr_used;
-  message::Table *_create_table;
 };
 
 extern void lex_start(Session *session);

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2010-12-28 16:57:38 +0000
+++ drizzled/sql_yacc.yy	2010-12-24 09:17:43 +0000
@@ -1060,47 +1060,25 @@
                                                    TL_WRITE))
               DRIZZLE_YYABORT;
             lex->col_list.empty();
+            statement->change=NULL;
             statement->is_if_not_exists= $4;
+            statement->create_info.db_type= NULL;
+            statement->create_info.default_table_charset= NULL;
+            lex->name.str= 0;
 
-            Lex->table()->set_name($5->table.str);
+	    message::Table &proto= statement->create_table_message;
+	   
+	    proto.set_name($5->table.str);
 	    if ($2)
-	      Lex->table()->set_type(message::Table::TEMPORARY);
+	      proto.set_type(message::Table::TEMPORARY);
 	    else
-	      Lex->table()->set_type(message::Table::STANDARD);
+	      proto.set_type(message::Table::STANDARD);
           }
           create2
           {
             LEX *lex= YYSession->lex;
             lex->current_select= &lex->select_lex;
           }
-        | CREATE opt_table_options TABLE_SYM opt_if_not_exists table_ident LIKE table_ident opt_create_table_options
-          {
-            Session *session= YYSession;
-            LEX *lex= session->lex;
-            lex->sql_command= SQLCOM_CREATE_TABLE;
-            statement::CreateTable *statement= new(std::nothrow) statement::CreateTable(YYSession);
-            lex->statement= statement;
-            if (lex->statement == NULL)
-              DRIZZLE_YYABORT;
-
-            if (!lex->select_lex.add_table_to_list(session, $5, NULL,
-                                                   TL_OPTION_UPDATING,
-                                                   TL_WRITE))
-              DRIZZLE_YYABORT;
-            lex->col_list.empty();
-            statement->is_if_not_exists= $4;
-
-            Lex->table()->set_name($5->table.str);
-	    if ($2)
-	      Lex->table()->set_type(message::Table::TEMPORARY);
-	    else
-	      Lex->table()->set_type(message::Table::STANDARD);
-
-            statement->is_create_table_like= true;
-
-            if (not lex->select_lex.add_table_to_list(session, $7, NULL, 0, TL_READ))
-              DRIZZLE_YYABORT;
-          }
         | CREATE build_method
           {
             LEX *lex=Lex;
@@ -1149,6 +1127,16 @@
           '(' create2a {}
         | opt_create_table_options
           create3 {}
+        | LIKE table_ident opt_create_table_options
+          {
+            Session *session= YYSession;
+            LEX *lex= session->lex;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+
+            statement->is_create_table_like= true;
+            if (!lex->select_lex.add_table_to_list(session, $2, NULL, 0, TL_READ))
+              DRIZZLE_YYABORT;
+          }
         | '(' LIKE table_ident ')'
           {
             Session *session= YYSession;
@@ -1301,24 +1289,33 @@
 custom_engine_option:
         ENGINE_SYM equal ident_or_text
           {
-            Lex->table()->mutable_engine()->set_name($3.str);
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+
+            statement->is_engine_set= true;
+
+            ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_engine()->set_name($3.str);
           }
         | COMMENT_SYM opt_equal TEXT_STRING_sys
           {
-            Lex->table()->mutable_options()->set_comment($3.str);
+	    message::Table::TableOptions *tableopts;
+	    tableopts= ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_options();
+
+	    tableopts->set_comment($3.str);
           }
         | AUTO_INC opt_equal ulonglong_num
           {
-            Lex->table()->mutable_options()->set_auto_increment_value($3);
-
-#if 0
+	    message::Table::TableOptions *tableopts;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+
+	    tableopts= ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_options();
+
             statement->create_info.auto_increment_value=$3;
             statement->create_info.used_fields|= HA_CREATE_USED_AUTO;
-#endif
+	    tableopts->set_auto_increment_value($3);
           }
         |  ident_or_text equal ident_or_text
           {
-	    drizzled::message::Engine::Option *opt= Lex->table()->mutable_engine()->add_options();
+	    drizzled::message::Engine::Option *opt= ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_engine()->add_options();
 
             opt->set_name($1.str);
             opt->set_state($3.str);
@@ -1328,7 +1325,7 @@
             char number_as_string[22];
             snprintf(number_as_string, sizeof(number_as_string), "%"PRIu64, $3);
 
-	    drizzled::message::Engine::Option *opt= Lex->table()->mutable_engine()->add_options();
+	    drizzled::message::Engine::Option *opt= ((statement::CreateTable *)Lex->statement)->create_table_message.mutable_engine()->add_options();
             opt->set_name($1.str);
             opt->set_state(number_as_string);
           }
@@ -1340,7 +1337,7 @@
           {
             statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
 
-            HA_CREATE_INFO *cinfo= &statement->create_info();
+            HA_CREATE_INFO *cinfo= &statement->create_info;
             if ((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                  cinfo->default_table_charset && $4 &&
                  !my_charset_same(cinfo->default_table_charset,$4))
@@ -1349,8 +1346,8 @@
                          $4->name, cinfo->default_table_charset->csname);
                 DRIZZLE_YYABORT;
               }
-              statement->create_info().default_table_charset= $4;
-              statement->create_info().used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
+              statement->create_info.default_table_charset= $4;
+              statement->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
           }
         ;
 
@@ -2403,9 +2400,9 @@
           {
             statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
 
-            statement->create_info().table_charset=
-            statement->create_info().default_table_charset= $3;
-            statement->create_info().used_fields|= (HA_CREATE_USED_CHARSET |
+            statement->create_info.table_charset=
+            statement->create_info.default_table_charset= $3;
+            statement->create_info.used_fields|= (HA_CREATE_USED_CHARSET |
               HA_CREATE_USED_DEFAULT_CHARSET);
             statement->alter_info.flags.set(ALTER_CONVERT);
           }

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2010-12-28 16:57:38 +0000
+++ drizzled/statement/alter_table.cc	2010-12-24 07:15:43 +0000
@@ -89,17 +89,15 @@
   Select_Lex *select_lex= &session->lex->select_lex;
   bool need_start_waiting= false;
 
-  is_engine_set= not createTableMessage().engine().name().empty();
-
   if (is_engine_set)
   {
-    create_info().db_type= 
-      plugin::StorageEngine::findByName(*session, createTableMessage().engine().name());
+    create_info.db_type= 
+      plugin::StorageEngine::findByName(*session, create_table_message.engine().name());
 
-    if (create_info().db_type == NULL)
+    if (create_info.db_type == NULL)
     {
       my_error(ER_UNKNOWN_STORAGE_ENGINE, MYF(0), 
-               createTableMessage().engine().name().c_str());
+               create_table_message.engine().name().c_str());
 
       return true;
     }
@@ -120,12 +118,12 @@
       return true;
     }
 
-    if (not  create_info().db_type)
+    if (not  create_info.db_type)
     {
-      create_info().db_type= 
+      create_info.db_type= 
         plugin::StorageEngine::findByName(*session, original_table_message->engine().name());
 
-      if (not create_info().db_type)
+      if (not create_info.db_type)
       {
         std::string path;
         identifier.getSQLPath(path);
@@ -155,9 +153,9 @@
     res= alter_table(session, 
                      identifier,
                      new_identifier,
-                     &create_info(),
+                     &create_info,
                      *original_table_message,
-                     createTableMessage(),
+                     create_table_message,
                      first_table,
                      &alter_info,
                      select_lex->order_list.elements,
@@ -178,9 +176,9 @@
       res= alter_table(session, 
                        identifier,
                        new_identifier,
-                       &create_info(),
+                       &create_info,
                        *original_table_message,
-                       createTableMessage(),
+                       create_table_message,
                        first_table,
                        &alter_info,
                        select_lex->order_list.elements,

=== modified file 'drizzled/statement/create_index.cc'
--- drizzled/statement/create_index.cc	2010-12-28 16:57:38 +0000
+++ drizzled/statement/create_index.cc	2010-12-18 04:43:40 +0000
@@ -65,14 +65,14 @@
   if (original_table_message->type() == message::Table::STANDARD )
   {
     TableIdentifier identifier(first_table->getSchemaName(), first_table->getTableName());
-    create_info().default_table_charset= plugin::StorageEngine::getSchemaCollation(identifier);
+    create_info.default_table_charset= plugin::StorageEngine::getSchemaCollation(identifier);
 
     res= alter_table(session, 
                      identifier,
                      identifier,
-                     &create_info(), 
+                     &create_info, 
                      *original_table_message,
-                     createTableMessage(), 
+                     create_table_message, 
                      first_table,
                      &alter_info,
                      0, (Order*) 0, 0);
@@ -84,14 +84,14 @@
     assert(table);
     {
       TableIdentifier identifier(first_table->getSchemaName(), first_table->getTableName(), table->getMutableShare()->getPath());
-      create_info().default_table_charset= plugin::StorageEngine::getSchemaCollation(identifier);
+      create_info.default_table_charset= plugin::StorageEngine::getSchemaCollation(identifier);
 
       res= alter_table(session, 
                        identifier,
                        identifier,
-                       &create_info(), 
+                       &create_info, 
                        *original_table_message,
-                       createTableMessage(), 
+                       create_table_message, 
                        first_table,
                        &alter_info,
                        0, (Order*) 0, 0);

=== modified file 'drizzled/statement/create_table.cc'
--- drizzled/statement/create_table.cc	2010-12-28 16:57:38 +0000
+++ drizzled/statement/create_table.cc	2010-12-27 20:04:50 +0000
@@ -37,26 +37,24 @@
   TableList *all_tables= session->lex->query_tables;
   assert(first_table == all_tables && first_table != 0);
   bool need_start_waiting= false;
-  lex_identified_temp_table= createTableMessage().type() == message::Table::TEMPORARY;
-
-  is_engine_set= not createTableMessage().engine().name().empty();
+  lex_identified_temp_table= create_table_message.type() == message::Table::TEMPORARY;
 
   if (is_engine_set)
   {
-    create_info().db_type= 
-      plugin::StorageEngine::findByName(*session, createTableMessage().engine().name());
+    create_info.db_type= 
+      plugin::StorageEngine::findByName(*session, create_table_message.engine().name());
 
-    if (create_info().db_type == NULL)
+    if (create_info.db_type == NULL)
     {
       my_error(ER_UNKNOWN_STORAGE_ENGINE, MYF(0), 
-               createTableMessage().engine().name().c_str());
+               create_table_message.engine().name().c_str());
 
       return true;
     }
   }
   else /* We now get the default, place it in create_info, and put the engine name in table proto */
   {
-    create_info().db_type= session->getDefaultStorageEngine();
+    create_info.db_type= session->getDefaultStorageEngine();
   }
 
   if (not validateCreateTableOption())
@@ -76,11 +74,11 @@
   /* Skip first table, which is the table we are creating */
   create_table_list= session->lex->unlink_first_table(&link_to_local);
 
-  drizzled::message::init(createTableMessage(), createTableMessage().name(), create_table_list->getSchemaName(), create_info().db_type->getName());
+  drizzled::message::init(create_table_message, create_table_message.name(), create_table_list->getSchemaName(), create_info.db_type->getName());
 
   TableIdentifier new_table_identifier(create_table_list->getSchemaName(),
                                        create_table_list->getTableName(),
-                                       createTableMessage().type());
+                                       create_table_message.type());
 
   if (not check(new_table_identifier))
   {
@@ -90,7 +88,7 @@
   }
 
   /* Might have been updated in create_table_precheck */
-  create_info().alias= create_table_list->alias;
+  create_info.alias= create_table_list->alias;
 
   /*
      The create-select command will open and read-lock the select table
@@ -172,8 +170,8 @@
         */
         if ((result= new select_create(create_table_list,
                                        is_if_not_exists,
-                                       &create_info(),
-                                       createTableMessage(),
+                                       &create_info,
+                                       create_table_message,
                                        &alter_info,
                                        select_lex->item_list,
                                        session->lex->duplicates,
@@ -203,7 +201,7 @@
                                new_table_identifier,
                                create_table_list, 
                                select_tables,
-                               createTableMessage(),
+                               create_table_message,
                                is_if_not_exists,
                                is_engine_set);
       }
@@ -212,15 +210,15 @@
 
         for (int32_t x= 0; x < alter_info.alter_proto.added_field_size(); x++)
         {
-          message::Table::Field *field= createTableMessage().add_field();
+          message::Table::Field *field= create_table_message.add_field();
 
           *field= alter_info.alter_proto.added_field(x);
         }
 
         res= create_table(session, 
                           new_table_identifier,
-                          &create_info(),
-                          createTableMessage(),
+                          &create_info,
+                          create_table_message,
                           &alter_info, 
                           false, 
                           0,
@@ -266,20 +264,20 @@
 bool statement::CreateTable::validateCreateTableOption()
 {
   bool rc= true;
-  size_t num_engine_options= createTableMessage().engine().options_size();
+  size_t num_engine_options= create_table_message.engine().options_size();
 
-  assert(create_info().db_type);
+  assert(create_info.db_type);
 
   for (size_t y= 0; y < num_engine_options; ++y)
   {
-    bool valid= create_info().db_type->validateCreateTableOption(createTableMessage().engine().options(y).name(),
-                                                                 createTableMessage().engine().options(y).state());
+    bool valid= create_info.db_type->validateCreateTableOption(create_table_message.engine().options(y).name(),
+                                                               create_table_message.engine().options(y).state());
 
     if (not valid)
     {
       my_error(ER_UNKNOWN_ENGINE_OPTION, MYF(0),
-               createTableMessage().engine().options(y).name().c_str(),
-               createTableMessage().engine().options(y).state().c_str());
+               create_table_message.engine().options(y).name().c_str(),
+               create_table_message.engine().options(y).state().c_str());
 
       rc= false;
     }

=== modified file 'drizzled/statement/create_table.h'
--- drizzled/statement/create_table.h	2010-12-28 16:57:38 +0000
+++ drizzled/statement/create_table.h	2010-12-27 20:04:50 +0000
@@ -42,9 +42,9 @@
       change(NULL),
       default_value(NULL),
       on_update_value(NULL),
-      is_engine_set(false),
       is_create_table_like(false),
       is_if_not_exists(false),
+      is_engine_set(false),
       lex_identified_temp_table(false),
       link_to_local(false),
       create_table_list(NULL)
@@ -59,28 +59,13 @@
   bool execute();
   virtual bool executeInner(TableIdentifier::const_reference);
 
-public:
+  message::Table create_table_message;
   message::Table &createTableMessage()
   {
-    return *session->lex->table();
+    return create_table_message;
   };
   message::Table::Field *current_proto_field;
-private:
-  HA_CREATE_INFO _create_info;
-
-public:
-
-  HA_CREATE_INFO &create_info()
-  {
-    if (createTableMessage().options().auto_increment_value())
-    {
-      _create_info.auto_increment_value= createTableMessage().options().auto_increment_value();
-      _create_info.used_fields|= HA_CREATE_USED_AUTO;
-    }
-
-    return _create_info;
-  }
-
+  HA_CREATE_INFO create_info;
   AlterInfo alter_info;
   KEY_CREATE_INFO key_create_info;
   message::Table::ForeignKeyConstraint::ForeignKeyMatchOption fk_match_option;
@@ -101,9 +86,9 @@
   /* Poly-use */
   LEX_STRING comment;
 
-  bool is_engine_set;
   bool is_create_table_like;
   bool is_if_not_exists;
+  bool is_engine_set;
   bool lex_identified_temp_table;
   bool link_to_local;
   TableList *create_table_list;

